#=========================================================
# ColorImporter.py
#
# Blender2.41
# Python Release 2.4.3 29 March 2006
#
# Auther: keina
#
# History:
#   2006.05.11(Thu)  Created
#
# CopyRight(c) 2006 K.Keina
# Mail: keines@ps.sakura.ne.jp
# Web : http://keines.gozaru.jp/blender/
#=========================================================

print '--- ColorImporter.py ---'
import Blender,re
from Blender import Draw, BGL, Window, Scene, Material, Library

# Other variables
Title		= 'ColorImporter'
Version		= 'ver.2006.05.11(Thu)'
Author		= ' by keines'
VerWidth	= Draw.GetStringWidth(Version+Author)

# + Cxgԍ
Event_None	= 0
Event_Menu	= 1
Event_Duplicate	= 2
Event_Users	= 3
Event_Select	= 4
Event_Input	= 5
Event_Execute	= 6
Event_Exit	= 7

# + `悷邽߂̊{l
SpcWidth	= 20
BaseHeight	= 20

# + j[֌W
MenuSelect	= 3
MenuName	= ['Presented','tsvFile','Blender'] # 1,2,3
MenuStr		= 'Menu Type %t'
MenuWidth	= 0
#   - j[̍쐬ƕvZĂ
for i in range(len(MenuName)):
    MenuStr+='|'+MenuName[i]+' %x'+str(i+1)
    k=Draw.GetStringWidth(MenuName[i])
    if MenuWidth<k:MenuWidth=k
    MenuName[i]=''
MenuWidth+=SpcWidth*2

#    - MenuNamẽCfbNX
Menu_Present	= 1
Menu_TSV	= 2
Menu_Blender	= 3

# + 
# ExtList=['*.tsv','*.blend']
BaseMaterial='Material'
TsvMenu = "Data Type %t|Decimal %x1|Hex %x2|Html %x3"
StrList=[['Duplicate',0],['users 0',0],['File',0],['>> ',0],['Execute',0],['Column: ',0],['Step',0],['X: ',0],['Y: ',0],['Exit',0]]
StrList_Duplicate= 0
StrList_Users	= 1
StrList_Select	= 2
StrList_Input	= 3
StrList_Execute	= 4
StrList_Column	= 5
StrList_Step	= 6
StrList_StepX	= 7
StrList_StepY	= 8
StrList_Exit	= 9
for i in range(len(StrList)):
    StrList[i][1]=Draw.GetStringWidth(StrList[i][0])

NumWidth=Draw.GetStringWidth('-100.00')+SpcWidth*2
MainWidth=StrList[StrList_Execute][1]+StrList[StrList_Column][1]+StrList[StrList_Step][1]+(NumWidth*2)+(SpcWidth*5+16)
InputWidth=MainWidth-(StrList[StrList_Select][1]+SpcWidth+4)

# {{^
InputBtn	= Draw.Create('')	# FilePath
ColumnBtn	= Draw.Create(12)
StepXBtn	= Draw.Create(2.0)
StepYBtn	= Draw.Create(2.0)
MenuBtn		= Draw.Create(MenuSelect)
TSVBtn		= Draw.Create(3)
DuplicateBtn	= Draw.Create(0)
UsersBtn	= Draw.Create(1)	# 1:Users=0Lɂ

# 2006.05.06(Sat) 14:44 u\nvǉ
# 0:Decimal,Hex  : D9,00
# 1:Html         : 01ABCF,0AB or #01ABCF,#0AB
RegExp=["([^\t]*)\t(\w+)\t(\w+)\t(\w+)\n$","([^\t]*)\t#?(\w\w?)(\w\w?)(\w\w?)\n$"]

#=========================================================
# Functions
#=========================================================
def ConfirmPopMenu(s):
    return Draw.PupMenu('Confirm.. %t|'+s+' %x1')

def DuplicateFunction(IsZero,MaterialList):
    print 'Duplicate Start'
    ### ŏɑIIuWFNg̊mF ###
    scn = Scene.GetCurrent()
    activeObject = scn.getActiveObject()
    if not activeObject:
        ConfirmPopMenu('ActiveObject not Found.')
        return
    ### ׂĂ̑IO ###
    for ob in Blender.Object.GetSelected():
        ob.sel = 0
    activeObject.sel = 1
    ### Ŝ̃}eAXg ###
    work=Material.Get()
    ### }eÂȂI ###
    if (len(work)==0):
        ConfirmPopMenu('Material is Zero.')
        return
    ### IIuWFNg̃}eA̐ݒmF ###
    me=activeObject.getData()
    if (not me.materials):
        # }eAPȏ゠肩}eAIIuWFNgɖݒ̂Ƃ
        # BaseMaterial ΂IIuWFNgɐݒ
        cnt=-1
        for i in work:
            cnt+=1
            if (i.name==BaseMaterial):
                mat=work[cnt]
                cnt=-1
                break
        if (cnt>-1):mat=Material.New(BaseMaterial)
        # IIuWFNgɃ}eAݒ
        me.materials=[mat]
        me.update()
        # 쐬XgBaseMaterial폜
        cnt=-1
        for i in MaterialList:
            cnt+=1
            if (i.name==BaseMaterial):
                del MaterialList[cnt]
                break
    ### Init ###
    # ẅړ
    w=StepXBtn.val
    # ẍړ
    h=StepYBtn.val
    #
    BaseX=activeObject.LocX+w
    BaseY=activeObject.LocY
    cnt=-1
    R=0
    G=0
    B=0
    try:
        # + dꂽMaterial͂Ȃ̂Ƃă[v
        if (IsZero==1):
            # - ׂẴ}eAΏۂƂ
            for work in MaterialList:
                cnt+=1
                # bV𕡐A}eA͍Ȃ
                Blender.Object.Duplicate(mesh=1,material=0)
                activeObject = scn.getActiveObject()
                activeObject.LocX=BaseX+(cnt%ColumnBtn.val)*w+w
                activeObject.LocY=BaseY-(cnt/ColumnBtn.val)*h
                # }eAKp
                me=activeObject.getData()
                me.materials[0]=work
                me.update()
                print "%4d:%s %s" % (cnt,activeObject.name,work.name)
        else:
            # - NĂȂ}eAr
            for work in MaterialList:
                if (work.users==0):continue
                cnt+=1
                # bV𕡐A}eA͍Ȃ
                Blender.Object.Duplicate(mesh=1,material=0)
                activeObject = scn.getActiveObject()
                activeObject.LocX=BaseX+(cnt%ColumnBtn.val)*w+w
                activeObject.LocY=BaseY-(cnt/ColumnBtn.val)*h
                # }eAKp
                me=activeObject.getData()
                me.materials[0]=work
                me.update()
                print "%4d:%s" % (cnt,work.name)
    except:
        ConfirmPopMenu(' error..')
    Blender.Redraw()

# }eAǂݍݑȌԂƂĂ炢
# ǉXgɂĕ֐s
def InitDuplicateFunction(IsZero,BeforeMaterial):
    AfterMaterial=Material.Get()
    # After  Before 폜ƒǉXgɂȂ
    for Before in BeforeMaterial:
        i=-1
        for After in AfterMaterial:
            i+=1
            if (Before.name==After.name):
                del AfterMaterial[i]
                break
    DuplicateFunction(IsZero,AfterMaterial)

# 2006.05.10(Wed) 02:13
#   Library.Load ͏dƂAŖOB
#   ̖O擾ɂ͂Ȃ̏KvH
def BlenderFunction(fn):
    MatStr='Material' 
    print 'Import Blender Material:',fn
    if (DuplicateBtn.val): BeforeMaterial=Material.Get()
    try:
        Library.Open(fn)
        groups = Library.LinkableGroups()
        if MatStr in groups:
            cnt=-1
            for db in Library.Datablocks(MatStr):
                Library.Load(db, MatStr, 0) # 0ɋCāc
                cnt+=1
                print "%4d:%s" % (cnt,db)
            Library.Update()
        Library.Close()
        Blender.Redraw()
    except:
        ConfirmPopMenu(' error..')
    if (DuplicateBtn.val): InitDuplicateFunction(1,BeforeMaterial)

# ^u`̐Ft@Cǂݍ
# ColorListDuplicator p
def TsvFunction(fn):
    ### Material List ###
    print 'Import TSV Color:',fn
    if (DuplicateBtn.val): BeforeMaterial=Material.Get()
    cnt=-1
    R=0
    G=0
    B=0
    try:
        f=open(fn)
        # skip header
        f.readline()
        # Html=RegExp[1]
        rexp=re.compile(RegExp[(TSVBtn.val==3)])
        for s in f.readlines():
            cnt+=1
            n=rexp.findall(s)
            if not n: continue
            n=n.pop(0)
            if (len(n[0])==0):n[0]=BaseName % (cnt+1)
            # 1:Decimal 2:Hex 3:Html
            if (TSVBtn.val==1):
                R=int(n[1],10)
                G=int(n[2],10)
                B=int(n[3],10)
            else:
                # Str(Hex) -> Int(Decimal)
                R=int(n[1], 16)
                G=int(n[2], 16)
                B=int(n[3], 16)
            # Change Int to float
            R=float(R)/255
            G=float(G)/255
            B=float(B)/255
            # INews
            mat=Material.New(n[0])
            mat.R=R
            mat.G=G
            mat.B=B
            print "%4d: R=%.3f  G=%.3f  B=%.3f  %s" % (cnt,mat.R,mat.G,mat.B,mat.name)
        Blender.Redraw()
    except:
        ConfirmPopMenu(' error..')
    f.close()
    if (DuplicateBtn.val): InitDuplicateFunction(1,BeforeMaterial)

# ݂̃}eAŕ
def PresentFunction():
    print 'Presented'
    scn = Scene.GetCurrent()
    activeObject = scn.getActiveObject()
    if activeObject:
        me=activeObject.getData()
        work=me.materials
        # IIuWFNg̐FȊOŕ
        InitDuplicateFunction(UsersBtn.val,work)

def ExecuteFunction(fn):
    if (MenuBtn.val==Menu_Present)	:PresentFunction()
    else:
        if not (Blender.sys.exists(fn)==1):
            ConfirmPopMenu('File not Found.')
        elif (MenuBtn.val==Menu_TSV)	: TsvFunction(fn)
        elif (MenuBtn.val==Menu_Blender): BlenderFunction(fn)

#=========================================================
# DrawEvent
#=========================================================
def DrawGui():
    global MenuBtn,TSVBtn,InputBtn,ColumnBtn,StepXBtn,StepYBtn,DuplicateBtn,UsersBtn
    # --- Init Screen ---
    BGL.glClearColor(0.6, 0.6, 0.6, 0.0)
    BGL.glClear(Blender.BGL.GL_COLOR_BUFFER_BIT)
    BGL.glColor3f(0.1, 0.1, 0.15) # Text Color
    # --- Get Screen Size ---
    size=Blender.BGL.Buffer(Blender.BGL.GL_FLOAT, 4)
    Blender.BGL.glGetFloatv(Blender.BGL.GL_SCISSOR_BOX, size)
    size= size.list
    # FLOAT -> INT
    for s in range(4): size[s]=int(size[s])
    # Base Position
    x=20
    y=size[3]-BaseHeight
    # + Title
    BGL.glRasterPos2f(x, y)
    Draw.Text(Title)
    # + Menu Button
    y-=BaseHeight*2
    MenuBtn = Draw.Menu(MenuStr, Event_Menu, x, y, MenuWidth, BaseHeight, MenuBtn.val)
    if (MenuBtn.val==Menu_Present):
        # + Button
        UsersBtn=Draw.Toggle(StrList[StrList_Users][0], Event_Users, x+MenuWidth+8, y, StrList[StrList_Users][1]+SpcWidth, BaseHeight, UsersBtn.val)
        #   - Import
        y-=BaseHeight*2-10
        w=StrList[StrList_Execute][1]+SpcWidth
        Draw.Button (StrList[StrList_Execute][0],Event_Execute,x,y,w,BaseHeight,"")
        #   - Column
        i=x+w+SpcWidth
        k=StrList[StrList_Column][1]+SpcWidth*2+8
        ColumnBtn=Draw.Number(StrList[StrList_Column][0], Event_None, i, y, k, BaseHeight, ColumnBtn.val, 1, 99)
        #   - StepX / StepY
        i+=k+SpcWidth
        BGL.glRasterPos2f(i, y+6)
        Draw.Text(StrList[StrList_Step][0])
        i+=StrList[StrList_Step][1]+4
        StepXBtn=Draw.Number(StrList[StrList_StepX][0], Event_None, i           , y, NumWidth, BaseHeight, StepXBtn.val, -100, 100)
        StepYBtn=Draw.Number(StrList[StrList_StepY][0], Event_None, i+NumWidth+4, y, NumWidth, BaseHeight, StepYBtn.val, -100, 100)
        y-=BaseHeight*2-10
    else:
        DuplicateBtn=Draw.Toggle(StrList[StrList_Duplicate][0], Event_Duplicate, x+MenuWidth+8, y, StrList[StrList_Duplicate][1]+SpcWidth, BaseHeight, DuplicateBtn.val)
        # + File Select
        y-=BaseHeight*2-10
        w=StrList[StrList_Select][1]+SpcWidth
        Draw.Button(StrList[StrList_Select][0],Event_Select,x,y,w,BaseHeight,InputBtn.val)
        InputBtn=Draw.String(StrList[StrList_Input][0], Event_Input, x+w+4, y, InputWidth, BaseHeight, MenuName[MenuBtn.val-1], 255)
        if (MenuBtn.val==Menu_TSV):
            TSVBtn = Draw.Menu(TsvMenu, Event_None, x+w+4+InputWidth+6, y, 80, BaseHeight, TSVBtn.val)
        # + Button
        #   - Import
        y-=BaseHeight*2-10
        w=StrList[StrList_Execute][1]+SpcWidth
        Draw.Button (StrList[StrList_Execute][0],Event_Execute,x,y,w,BaseHeight,"")
        #   - Duplicate Enable
        if (DuplicateBtn.val):
            #   - Column
            i=x+w+SpcWidth
            k=StrList[StrList_Column][1]+SpcWidth*2+8
            ColumnBtn=Draw.Number(StrList[StrList_Column][0], Event_None, i, y, k, BaseHeight, ColumnBtn.val, 1, 99)
            #   - StepX / StepY
            i+=k+SpcWidth
            BGL.glRasterPos2f(i, y+6)
            Draw.Text(StrList[StrList_Step][0])
            i+=StrList[StrList_Step][1]+4
            StepXBtn=Draw.Number(StrList[StrList_StepX][0], Event_None, i           , y, NumWidth, BaseHeight, StepXBtn.val, -100, 100)
            StepYBtn=Draw.Number(StrList[StrList_StepY][0], Event_None, i+NumWidth+4, y, NumWidth, BaseHeight, StepYBtn.val, -100, 100)
    # + Version
    y-=BaseHeight*2-10
    BGL.glRasterPos2f(x+MainWidth-VerWidth, y)
    Draw.Text(Version+Author)
    # + Exit Button
    y-=BaseHeight*2-10
    Draw.Button (StrList[StrList_Exit][0],Event_Exit,x,y,StrList[StrList_Exit][1]+SpcWidth,BaseHeight,"")

#=========================================================
# ButtonEvent
#=========================================================
def FileSelectFunction(fn):
    InputBtn.val=fn
    MenuName[MenuBtn.val-1]=fn

def ExitFunction():
    if ConfirmPopMenu('Exit Script ?')==1:
        print 'Exit.'
        Draw.Exit()
        return

def ButtonEvent(evt):
    global MenuName
    if evt in [Event_Menu,Event_Duplicate]: Draw.Register(DrawGui, KeyEvent, ButtonEvent)
    elif (evt==Event_Select)	: Window.FileSelector (FileSelectFunction, 'File Select..')
    elif (evt==Event_Input)	: MenuName[MenuBtn.val-1]=InputBtn.val
    elif (evt==Event_Execute)	: ExecuteFunction(InputBtn.val)
    elif (evt==Event_Exit)	: ExitFunction()

#=========================================================
# KeyEvent
#=========================================================
def KeyEvent(evt, val):
    # val: 1=KeyDown 0=KeyUp
    if (not val) :return
    if evt in [Draw.ESCKEY, Draw.QKEY]:ExitFunction()

#=========================================================
# Main
#=========================================================
Draw.Register(DrawGui, KeyEvent, ButtonEvent)
